local module, workspace = {["buttons"] = {};}, {["children"] = {};}

function module.new(input)
	local instance = {}
	for property, value in next, input do
		instance[property] = value;
	end;
	instance.children = {}
	if (instance.parent) then
		instance.parent.children[(#instance.parent.children) + 1] = instance;
	end
	if (instance.button) then
		module.buttons[(#module.buttons) + 1] = instance;
	end
	return (instance);
end;

function module.isButton(instance)
	instance.button = true;
	module.buttons[(#module.buttons) + 1] = instance;
	return (instance);
end;

function module.notButton(instance)
	instance.button = false;
	for x = 1, (#module.buttons), 1 do
		if (module.buttons[x] == instance) then
			table.remove(module.buttons, x)
			break
		end
	end
	return (instance);
end;

function module.reparent(instance, parent)
	instance.parent = parent;
	if (instance.parent) then
		instance.parent.children[(#instance.parent.children) + 1] = instance;
	end
end;

return ({module; workspace;});