local instanceModule = require(".\\instance")
instance, workspace = instanceModule[1], instanceModule[2]

love.load = function()
	instance.new({
		button = true;
		class = "rectangle";
		colorR = 128;
		colorG = 128;
		colorB = 128;
		drawMode = "fill";
		parent = workspace;
		positionX = 500;
		positionY = 1000;
		sizeX = 500;
		sizeY = 750;
	}).buttonFunction = function(self)
		self.colorR = math.random(0, 255);
		self.colorG = math.random(0, 255);
		self.colorB = math.random(0, 255);
		return (nil);
	end;
	return (nil);
end;

love.update = function()
end;

function love.mousepressed(x, y, button, touch)
	for z = 1, (#instance.buttons), 1 do
		local button = instance.buttons[z]
		if (
			(x >= button.positionX) and
			(x <= (button.positionX + button.sizeX)) and
			(y >= button.positionY) and
			(y <= (button.positionY + button.sizeY))
		) then
			if (button.buttonFunction) then
				button.buttonFunction(button)
			end
			return (nil);
		end
	end
	return (nil);
end;

love.draw = function()
	local children, x = {}, 1
	for y = 1, (#workspace.children), 1 do
		children[(#children) + 1] = workspace.children[y];
	end
	while (children[x]) do
		local instance = children[x]
		if (instance.class == "rectangle") then
			love.graphics.setColor(instance.colorR, instance.colorG, instance.colorB, 255)
			love.graphics.rectangle(instance.drawMode, instance.positionX, instance.positionY, instance.sizeX, instance.sizeY)
		end
		for y = 1, (#instance.children), 1 do
			children[#children + 1] = instance.children[y];
		end
		x = (x + 1)
	end
	return (nil);
end;